org.apache.tinkerpop.gremlin.process.traversal.step.branch

## Class BranchStep<S,E,M>

- java.lang.Object
- - org.apache.tinkerpop.gremlin.process.traversal.step.util.AbstractStep<S,E>
  - - org.apache.tinkerpop.gremlin.process.traversal.step.util.ComputerAwareStep<S,E>
    - - org.apache.tinkerpop.gremlin.process.traversal.step.branch.BranchStep<S,E,M>

- All Implemented Interfaces:
    Serializable, AutoCloseable, Cloneable, Iterator<Traverser.Admin<E>>, Step<S,E>, GraphComputing, TraversalOptionParent<M,S,E>, TraversalParent
  Direct Known Subclasses:
    ChooseStep, UnionStep

      public class BranchStep<S,E,M>
      extends ComputerAwareStep<S,E>
      implements TraversalOptionParent<M,S,E>

  Author:
    Marko A. Rodriguez (http://markorodriguez.com), Daniel Kuppitz (http://gremlin.guru)
  See Also:
    Serialized Form

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class org.apache.tinkerpop.gremlin.process.traversal.step.util.ComputerAwareStep

      `ComputerAwareStep.EndStep<S>`

    - ### Nested classes/interfaces inherited from interface org.apache.tinkerpop.gremlin.process.traversal.step.TraversalOptionParent

      `TraversalOptionParent.Pick`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected Traversal.Admin<S,M>` | `branchTraversal`
    `protected List<org.javatuples.Pair<Traversal.Admin,Traversal.Admin<S,E>>>` | `traversalOptions`
    `protected Map<TraversalOptionParent.Pick,List<Traversal.Admin<S,E>>>` | `traversalPickOptions`

    - ### Fields inherited from class org.apache.tinkerpop.gremlin.process.traversal.step.util.AbstractStep

      `id, labels, nextEnd, nextStep, previousStep, starts, traversal, traverserStepIdAndLabelsSetByChild`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `BranchStep(Traversal.Admin traversal)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addGlobalChildOption(M pickToken, Traversal.Admin<S,E> traversalOption)`
    `BranchStep<S,E,M>` | `clone()` Cloning is used to duplicate steps for the purpose of traversal optimization and OLTP replication.
    `protected Iterator<Traverser.Admin<E>>` | `computerAlgorithm()`
    `List<Traversal.Admin<S,E>>` | `getGlobalChildren()`
    `List<Traversal.Admin<S,M>>` | `getLocalChildren()`
    `Set<TraverserRequirement>` | `getRequirements()` Provide the necessary `TraverserRequirement` that must be met by the traverser in order for the step to function properly.
    `int` | `hashCode()`
    `void` | `reset()` Reset the state of the step such that it has no incoming starts.
    `void` | `setBranchTraversal(Traversal.Admin<S,M> branchTraversal)`
    `void` | `setTraversal(Traversal.Admin<?,?> parentTraversal)` Set the `Traversal` that this step is contained within.
    `protected Iterator<Traverser.Admin<E>>` | `standardAlgorithm()`
    `String` | `toString()`

    - ### Methods inherited from class org.apache.tinkerpop.gremlin.process.traversal.step.util.ComputerAwareStep

      `onGraphComputer, processNextStart`

    - ### Methods inherited from class org.apache.tinkerpop.gremlin.process.traversal.step.util.AbstractStep

      `addLabel, addStart, addStarts, equals, getId, getLabels, getNextStep, getPreviousStep, getStarts, getTraversal, hasNext, hasStarts, isTraverserStepIdAndLabelsSetByChild, next, prepareTraversalForNextStep, removeLabel, setId, setNextStep, setPreviousStep`

    - ### Methods inherited from class java.lang.Object

      `finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface org.apache.tinkerpop.gremlin.process.traversal.step.TraversalParent

      `addGlobalChild, addLocalChild, asStep, close, getSelfAndChildRequirements, integrateChild, removeGlobalChild, removeLocalChild, replaceLocalChild`

    - ### Methods inherited from interface org.apache.tinkerpop.gremlin.process.traversal.step.GraphComputing

      `atMaster, atMaster`

    - ### Methods inherited from interface org.apache.tinkerpop.gremlin.process.traversal.Step

      `equals`

    - ### Methods inherited from interface java.util.Iterator

      `forEachRemaining, remove`

- - ### Field Detail

    - #### branchTraversal

          protected Traversal.Admin<S,M> branchTraversal

    - #### traversalPickOptions

          protected Map<TraversalOptionParent.Pick,List<Traversal.Admin<S,E>>> traversalPickOptions

    - #### traversalOptions

          protected List<org.javatuples.Pair<Traversal.Admin,Traversal.Admin<S,E>>> traversalOptions

  - ### Constructor Detail

    - #### BranchStep

          public BranchStep(Traversal.Admin traversal)

  - ### Method Detail

    - #### setBranchTraversal

          public void setBranchTraversal(Traversal.Admin<S,M> branchTraversal)

    - #### addGlobalChildOption

          public void addGlobalChildOption(M pickToken,
                                           Traversal.Admin<S,E> traversalOption)

      Specified by:
        `addGlobalChildOption` in interface `TraversalOptionParent<M,S,E>`

    - #### getRequirements

          public Set<TraverserRequirement> getRequirements()

      Description copied from interface: `Step`
      Provide the necessary `TraverserRequirement` that must be met by the traverser in order for the step to function properly. The provided default implements returns an empty set.
      Specified by:
        `getRequirements` in interface `Step<S,E>`
      Returns:
        the set of requirements

    - #### getGlobalChildren

          public List<Traversal.Admin<S,E>> getGlobalChildren()

      Specified by:
        `getGlobalChildren` in interface `TraversalParent`

    - #### getLocalChildren

          public List<Traversal.Admin<S,M>> getLocalChildren()

      Specified by:
        `getLocalChildren` in interface `TraversalParent`

    - #### standardAlgorithm

          protected Iterator<Traverser.Admin<E>> standardAlgorithm()

      Specified by:
        `standardAlgorithm` in class `ComputerAwareStep<S,E>`

    - #### computerAlgorithm

          protected Iterator<Traverser.Admin<E>> computerAlgorithm()

      Specified by:
        `computerAlgorithm` in class `ComputerAwareStep<S,E>`

    - #### clone

          public BranchStep<S,E,M> clone()

      Description copied from interface: `Step`
      Cloning is used to duplicate steps for the purpose of traversal optimization and OLTP replication. When cloning a step, it is important that the steps, the cloned step is equivalent to the state of the step when `Step.reset()` is called. Moreover, the previous and next steps should be set to `EmptyStep`.
      Specified by:
        `clone` in interface `Step<S,E>`
      Overrides:
        `clone` in class `ComputerAwareStep<S,E>`
      Returns:
        The cloned step

    - #### setTraversal

          public void setTraversal(Traversal.Admin<?,?> parentTraversal)

      Description copied from interface: `Step`
      Set the `Traversal` that this step is contained within.
      Specified by:
        `setTraversal` in interface `Step<S,E>`
      Overrides:
        `setTraversal` in class `AbstractStep<S,E>`
      Parameters:
        `parentTraversal` - the new traversal for this step

    - #### hashCode

          public int hashCode()

      Overrides:
        `hashCode` in class `AbstractStep<S,E>`

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `AbstractStep<S,E>`

    - #### reset

          public void reset()

      Description copied from interface: `Step`
      Reset the state of the step such that it has no incoming starts. Internal states are to be reset, but any sideEffect data structures are not to be recreated.
      Specified by:
        `reset` in interface `Step<S,E>`
      Overrides:
        `reset` in class `ComputerAwareStep<S,E>`

Copyright © 2013–2022 Apache Software Foundation. All rights reserved.